"use strict";

exports.__esModule = true;
exports.SENKA_QUESTS = exports.QUARTERLY_QUEST_REFRESH_MONTH = exports.MILLISECONDS_OF_24_HOURS = exports.MILLISECONDS_OF_1_HOUR = exports.MILLISECONDS_OF_12_HOURS = exports.EX_MAPS = exports.EXPERIENCE_TO_SENKA_RATE = exports.EMPTY_ARCHIVE = void 0;

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const MILLISECONDS_OF_1_HOUR = 1000 * 60 * 60;
exports.MILLISECONDS_OF_1_HOUR = MILLISECONDS_OF_1_HOUR;
const MILLISECONDS_OF_12_HOURS = MILLISECONDS_OF_1_HOUR * 12;
exports.MILLISECONDS_OF_12_HOURS = MILLISECONDS_OF_12_HOURS;
const MILLISECONDS_OF_24_HOURS = MILLISECONDS_OF_1_HOUR * 24;
exports.MILLISECONDS_OF_24_HOURS = MILLISECONDS_OF_24_HOURS;
const EX_MAPS = {
  15: 75,
  16: 75,
  25: 100,
  35: 150,
  45: 180,
  55: 200,
  65: 250,
  75: 170
};
exports.EX_MAPS = EX_MAPS;
const EXPERIENCE_TO_SENKA_RATE = 7 / 10000;
exports.EXPERIENCE_TO_SENKA_RATE = EXPERIENCE_TO_SENKA_RATE;
const SENKA_QUESTS = [{
  id: 854,
  senka: 350,
  name: '戦果拡張任務！「Z作戦」前段作戦',
  shortname: 'Z作戦前',
  code: 'Bq2'
}, {
  id: 888,
  senka: 200,
  name: '新編成「三川艦隊」、鉄底海峡に突入せよ！',
  shortname: '三川艦隊',
  code: 'Bq7'
}, {
  id: 893,
  senka: 300,
  name: '泊地周辺海域の安全確保を徹底せよ！',
  shortname: '泊地周辺',
  code: 'Bq8'
}, {
  id: 872,
  senka: 400,
  name: '戦果拡張任務！「Z作戦」後段作戦',
  shortname: 'Z作戦後',
  code: 'Bq10'
}, {
  id: 284,
  senka: 80,
  name: '南西諸島方面「海上警備行動」発令！',
  shortname: '海上警備',
  code: 'Bq11'
}, {
  id: 845,
  senka: 330,
  name: '発令！「西方海域作戦」',
  shortname: '西方海域',
  code: 'Bq12'
}, {
  id: 903,
  senka: 390,
  name: '拡張「六水戦」、最前線へ！',
  shortname: '六水戦',
  code: 'Bq13'
}]; // Zero-based: March, June, September, December

exports.SENKA_QUESTS = SENKA_QUESTS;
const QUARTERLY_QUEST_REFRESH_MONTH = [2, 5, 8, 11];
exports.QUARTERLY_QUEST_REFRESH_MONTH = QUARTERLY_QUEST_REFRESH_MONTH;
const EMPTY_ARCHIVE = {
  experienceHistory: {},
  rank5: {},
  rank20: {},
  rank100: {},
  rank501: {},
  rankUser: {},
  targetSenka: 3600,
  exHistory: {},
  questHistory: {},
  excludedQuests: [],
  magic: -1,
  currentRank: -1,
  date: _momentTimezone.default.tz('Asia/Tokyo').format()
};
exports.EMPTY_ARCHIVE = EMPTY_ARCHIVE;