"use strict";

exports.__esModule = true;
exports.reducer = void 0;

const reducer = (state = [], payload) => {
  const {
    type
  } = payload;

  switch (type) {
    case '@@poi-plugin-senka-calc/initialize':
      {
        const {
          archive
        } = payload;
        return archive.excludedQuests || state;
      }

    case '@@poi-plugin-senka-calc/update-excluded-quests':
      {
        const {
          value
        } = payload;
        const set = new Set(state);

        if (set.has(value)) {
          set.delete(value);
        } else {
          set.add(value);
        }

        return [...set];
      }

    default:
      {
        return state;
      }
  }
};

exports.reducer = reducer;