"use strict";

exports.__esModule = true;
exports.reducer = void 0;

var _redux = require("redux");

var _exHistory = require("./ex-history");

var _experienceHistory = require("./experience-history");

var _questHistory = require("./quest-history");

var _rankFactory = require("./rank-factory");

var _currentRank = require("./current-rank");

var _targetSenka = require("./target-senka");

var _excludedQuests = require("./excluded-quests");

const reducer = (0, _redux.combineReducers)({
  experienceHistory: _experienceHistory.reducer,
  rank5: (0, _rankFactory.reducerFactory)(5),
  rank20: (0, _rankFactory.reducerFactory)(20),
  rank100: (0, _rankFactory.reducerFactory)(100),
  rank501: (0, _rankFactory.reducerFactory)(501),
  rankUser: (0, _rankFactory.reducerFactory)('user'),
  exHistory: _exHistory.reducer,
  questHistory: _questHistory.reducer,
  currentRank: _currentRank.reducer,
  targetSenka: _targetSenka.reducer,
  excludedQuests: _excludedQuests.reducer
});
exports.reducer = reducer;